unit popts;

{$MODE OBJFPC}

interface

uses sysutils;

const multw1 = 1;
      multw3 = 3;
      multw5 = 5;
      multw9 = 9;
      multw10 = 10;

function multiply_w_lea_64( const val: Int64 ): Int64;
function multiply_w_lea_32( const val: LongInt ): LongInt;

{change "and const1, reg; and const2, reg" to "and (const1 and const2), reg"} 
function and_and_const_S( const val: Int64 ): Int64;
function and_and_const_U( const val: QWord ): QWord;

{change "and x, reg; jxx" to "test x, reg", if reg is deallocated before the
    jump, but only if it's a conditional jump (PFV) }
function and_jcond_to_test_jcond( const val: Int64 ): Boolean;

{change "and x, reg; test reg, reg; jxx" to "test x, reg; jxx", if reg is deallocated before the
    jump, but only if it's a conditional jump}
function and_test_jcond_to_test_jcond( const val: Int64 ): Boolean;

{change code sequence
 shr/sar const1, x
 shl     const2, x}
 
{with const1 > const2 }
function sar_shl_const1GT2_S( const val: Int64 ): Int64;
function shr_shl_const1GT2_U( const val: QWord ): QWord;

{with const1 < const2 }
function sar_shl_const1LT2_S( const val: Int64 ): Int64;
function shr_shl_const1LT2_U( const val: QWord ): QWord;

{with const1 = const2 }
function sar_shl_const1EQU2_S( const val: Int64 ): Int64;
function shr_shl_const1EQU2_U( const val: QWord ): QWord;

implementation

function multiply_w_lea_64( const val: Int64 ): Int64;
var res: Int64;
begin
  Result := 0;
  res := val * multw1; 
  Result := Result + res * multw1;
  res := val * multw3; 
  Result := Result + res * multw1;
  res := val * multw5; 
  Result := Result + res * multw1;
  res := val * multw9; 
  Result := Result + res * multw1;
  res := val * multw10; 
  Result := Result + res * multw1;
end;

function multiply_w_lea_32( const val: LongInt ): LongInt;
var res: LongInt;
begin
  Result := 0;
  res := val * multw1; 
  Result := Result + res * multw1;
  res := val * multw3; 
  Result := Result + res * multw1;
  res := val * multw5; 
  Result := Result + res * multw1;
  res := val * multw9; 
  Result := Result + res * multw1;
  res := val * multw10; 
  Result := Result + res * multw1;
end;

function and_test_jcond_to_test_jcond2( const val: Int64 ): Boolean;
begin
  if ( val and Byte($F) ) = 0 then
    Result := true
  else
    Result := false;
  if ( val and Word($FF) ) <> 0 then
    Result := Result and true
  else
    Result := Result and false;
end;

function and_test_jcond_to_test_jcond( const val: Int64 ): Boolean;
begin
  if ( val and $F ) = 0 then
    Result := true
  else
    Result := false;
  if ( val and $FF ) <> 0 then
    Result := Result and true
  else
    Result := Result and false;
end;

function and_jcond_to_test_jcond( const val: Int64 ): Boolean;
begin
  {couldnt find an expr that generates andX x,%reg; jxx, it seems every comparision
   is transformed either in testX ..; jxx or cmpX ..; jxx}
{$WARNING some language construct that generates andX x,%reg; jxx }
end;

function and_and_const_S( const val: Int64 ): Int64;
begin
  Result := val;
  Result := Result and $7;
  Result := Result and $F;
end;

function and_and_const_U( const val: QWord ): QWord;
begin
  Result := val;
  Result := Result and $7;
  Result := Result and $F;
end;

function sar_shl_const1GT2_S( const val: Int64 ): Int64;
begin
  Result := val;
  Result := Result shr Integer(7);
  Result := Result shl 3;
end;

function shr_shl_const1GT2_U( const val: QWord ): QWord;
begin
  Result := val;
  Result := Result shr 7;
  Result := Result shl 3;
end;

function sar_shl_const1LT2_S( const val: Int64 ): Int64;
begin
  Result := val;
  Result := Result shr 3;
  Result := Result shl 7;
end;

function shr_shl_const1LT2_U( const val: QWord ): QWord;
begin
  Result := val;
  Result := Result shr 3;
  Result := Result shl 7;
end;

function sar_shl_const1EQU2_S( const val: Int64 ): Int64;
begin
  Result := val;
  Result := Result shr 5;
  Result := Result shl 5;
end;

function shr_shl_const1EQU2_U( const val: QWord ): QWord;
begin
  Result := val;
  Result := Result shr 5;
  Result := Result shl 5;
end;

end.